//
//  ViewController.m
//  test_webview
//
//  Created by Hans Knöchel on 10.02.18.
//  Copyright © 2018 Hans Knöchel. All rights reserved.
//

#import "ViewController.h"
#import "LocalProtocolHandler.h"

@interface ViewController ()
@property (weak, nonatomic) IBOutlet UIWebView *_webView;
@end

@implementation ViewController

- (void)viewDidLoad {
  [super viewDidLoad];
  
  // README: See LocalProtocolhandler.m, line #36 to debug the injection that becomes nil in 11.3+
  
  [NSURLProtocol registerClass:[LocalProtocolHandler class]];

  NSString *path = [[NSBundle mainBundle] pathForResource:@"test" ofType:@"html"];

  [self._webView setDelegate:self];
  [self loadFile:path encoding:NSUTF8StringEncoding textEncodingName:@"utf-8" mimeType:@"test/html"];
}

- (void)loadFile:(NSString *)absolutePath
        encoding:(NSStringEncoding)encoding
textEncodingName:(NSString *)textEncodingName
        mimeType:(NSString *)mimeType
{
  NSURL *requestURL = [NSURL fileURLWithPath:absolutePath];
  NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:requestURL];
  [NSURLProtocol setProperty:textEncodingName forKey:@"kContentTextEncoding" inRequest:request];
  [NSURLProtocol setProperty:mimeType forKey:@"kContentMimeType" inRequest:request];
  
  [self._webView loadRequest:request];
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
  [NSURLProtocol setProperty:[self injection] forKey:@"kContentInjection" inRequest:(NSMutableURLRequest *)request];
  return YES;
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
  
}

- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
  
}

- (NSString *)injection
{
  return @"myKey";
}

@end
